#include "Status.h"
#include "Vram.h"
#include "Print.h"
#include "Chars.h"
#include "Sprite.h"
// #include "CopyMemory.h"

extern byte[] Chars;

static void PrintS(word vram, ptr<byte> p)
{
    byte c;
    Locate(vram, false);
    while ((c = *p) != 0) {
        PrintC(c);
        ++p;
    }
}


void PrintStatus()
{
    PrintS(Vram + VramRowSize * 0 + 21, "SCORE");
    PrintS(Vram + VramRowSize * 3 + 21, "HIGH");
    PrintS(Vram + VramRowSize * 4 + 21, "SCORE");
    PrintS(Vram + VramRowSize * 7 + 21, "STAGE");
    PrintByteNumber2(Vram + VramRowSize * 8 + 23, CurrentStage + 1);
    PrintRemain();
    PrintScore();
}

void PrintScore()
{
    PrintNumber5(Vram + VramRowSize * 1 + 21, Score);
    PrintC('0');

    PrintNumber5(Vram + VramRowSize * 5 + 21, HiScore);
    PrintC('0');
}

void PrintRemain()
{
    word vram, pPattern;
    vram = Vram + VramRowSize * 21 + 21;
    if (RemainCount > 1) {
        vram = Put2C(vram, Char_Remain);
        vram += VramRowSize;
        Locate(vram, false);
        if (RemainCount >= 3) {
            PrintC(RemainCount + ('0' - 1));
        }
        else {
            PrintC(' ');
        }
    }
    else {
        Erase2(vram);    
    }
}


void PrintGameOver()
{
    PrintS(Vram + VramRowSize * (VramHeight / 2) + 8, "GAME OVER");
}

void Title()
{
    ClearScreen(); 
    HideAllSprites();
    // UpdateSprites();
    PrintStatus();
    {
        static const byte[] TitleBytes = {
            //	G
            0x00, 0x0e, 0x05, 0x0b, 
            0x0c, 0x03, 0x0a, 0x0a, 
            0x04, 0x0b, 0x00, 0x0f, 
            0x00, 0x04, 0x05, 0x05, 
            //	U
            0x0c, 0x03, 0x00, 0x0f, 
            0x0c, 0x03, 0x00, 0x0f, 
            0x0c, 0x03, 0x00, 0x0f, 
            0x00, 0x05, 0x05, 0x01, 
            //	N
            0x0c, 0x0b, 0x00, 0x0f, 
            0x0c, 0x0f, 0x0b, 0x0f, 
            0x0c, 0x03, 0x0d, 0x0f, 
            0x04, 0x01, 0x00, 0x05, 
            //	T
            0x04, 0x0d, 0x07, 0x01, 
            0x00, 0x0c, 0x03, 0x00, 
            0x00, 0x0c, 0x03, 0x00, 
            0x00, 0x04, 0x01, 0x00, 
            //	U
            0x0c, 0x03, 0x00, 0x0f, 
            0x0c, 0x03, 0x00, 0x0f, 
            0x0c, 0x03, 0x00, 0x0f, 
            0x00, 0x05, 0x05, 0x01, 
            //	S
            0x08, 0x07, 0x05, 0x0b, 
            0x04, 0x0b, 0x0a, 0x02, 
            0x08, 0x02, 0x00, 0x0f, 
            0x00, 0x05, 0x05, 0x01, 
        };
        constexpr byte LogoLength = 6;
        constexpr byte Left = (WindowWidth - LogoLength * 4) / 2;
        ptr<byte> p;
        word vram;
        byte xMod;
        vram = Vram + VramRowSize * 7 + Left * 3 / 4;
        p = TitleBytes;
        repeat (LogoLength) {
            repeat (4) {
                xMod = Left & 3;
                repeat (4) {
                    PutShift(vram, xMod, *p);
                    ++p;
                    xMod += 6;
                    if (xMod >= 8) {
                        xMod -= 8;
                        ++vram;
                    }
                }
                vram += VramRowSize - 3;
            }
            vram += 3 - VramRowSize * 4;
        }
    }
    PrintS(Vram + VramRowSize * 19 + 7, "PUSH SPACE KEY");
    PrintS(Vram + VramRowSize * 20 + 7, "OR SHIFT KEY");
    PrintS(Vram + VramRowSize * 23 + 15, "INUFUTO 2022");
    // {
    //     byte c;
    //     word vram;
    //     vram = Vram;
    //     c = 0;
    //     repeat (0) {
    //         *vram = c; ++vram;
    //         ++c;
    //         if ((c & 15) == 0) {
    //             vram += VramRowSize - 16;
    //         }
    //     }
    // }
}


void AddScore(word pts)
{
    Score += pts;
    if (Score > HiScore) {
        HiScore = Score;
    }
    PrintScore();
}
