include "Vram.inc"
include "VVram.inc"
include "Chars.inc"

ext Status_

dseg
VVram_: public VVram_
    defs VVramWidth*VVramHeight
RowFlags_: public RowFlags_
    defs 4
SpSave:
    defw 0


; void ClearVVram();
cseg
ClearVVram_: public ClearVVram_
    push af | push hl | push de | push bc
        ld (SpSave),sp
        ld hl,VVram_+VVramWidth*VVramHeight
        ld de,VVramWidth*VVramHeight/2
        ld bc,(Char_Space shl 8) or Char_Space
        di
            ld sp,hl
            do
                push bc
                dec de
                ld a,e
                or d
            while nz | wend
            ld hl,(SpSave)
            ld sp,hl
        ei
    pop bc | pop de | pop hl | pop af
ret


; ptr<byte> VVramPtr(byte x, byte y);
cseg
VVramPtr_: public VVramPtr_
    push de
        ex af,af'
            ld a,e
            add a,a ;*2
            add a,a ;*4
            add a,a ;*8
            sub e ;*7
            ld e,a
        ex af,af'
        ex de,hl
            ld h,0
            add hl,hl ;*14
            add hl,hl ;*28
        ex de,hl
        ld l,a
        ld h,0
        add hl,de
        ld de,VVram_
        add hl,de
    pop de
ret
